Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesSingleObjectiveEvaluator.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesSingleObjectiveEvaluator.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesSingleObjectiveEvaluator.cs	(revision 9262)
@@ -0,0 +1,100 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+namespace HeuristicLab.Problems.TradeRules {
+  [StorableClass]
+    public abstract class TradeRulesSingleObjectiveEvaluator : TradeRulesAnalysisSingleObjectiveEvaluator<IRegressionProblemData>, ISymbolicRegressionSingleObjectiveEvaluator
+    {
+    private const string ApplyLinearScalingParameterName = "ApplyLinearScaling";
+    public IFixedValueParameter<BoolValue> ApplyLinearScalingParameter {
+      get { return (IFixedValueParameter<BoolValue>)Parameters[ApplyLinearScalingParameterName]; }
+    }
+    public bool ApplyLinearScaling {
+      get { return ApplyLinearScalingParameter.Value.Value; }
+      set { ApplyLinearScalingParameter.Value.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected TradeRulesSingleObjectiveEvaluator(bool deserializing) : base(deserializing) { }
+    protected TradeRulesSingleObjectiveEvaluator(TradeRulesSingleObjectiveEvaluator original, Cloner cloner) : base(original, cloner) { }
+    protected TradeRulesSingleObjectiveEvaluator()
+      : base() {
+      Parameters.Add(new FixedValueParameter<BoolValue>(ApplyLinearScalingParameterName, "Flag that indicates if the individual should be linearly scaled before evaluating.", new BoolValue(false)));
+      ApplyLinearScalingParameter.Hidden = true;
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (!Parameters.ContainsKey(ApplyLinearScalingParameterName)) {
+        Parameters.Add(new FixedValueParameter<BoolValue>(ApplyLinearScalingParameterName, "Flag that indicates if the individual should be linearly scaled before evaluating.", new BoolValue(false)));
+        ApplyLinearScalingParameter.Hidden = true;
+      }
+    }
+
+    [ThreadStatic]
+    private static double[] cache;
+
+    protected static void CalculateWithScaling(IEnumerable<double> targetValues, IEnumerable<double> estimatedValues,
+      double lowerEstimationLimit, double upperEstimationLimit,
+      IOnlineCalculator calculator, int maxRows) {
+      if (cache == null || cache.GetLength(0) < maxRows) {
+        cache = new double[maxRows];
+      }
+
+      //calculate linear scaling
+      //the static methods of the calculator could not be used as it performs a check if the enumerators have an equal amount of elements
+      //this is not true if the cache is used
+      int i = 0;
+      var linearScalingCalculator = new OnlineLinearScalingParameterCalculator();
+      var targetValuesEnumerator = targetValues.GetEnumerator();
+      var estimatedValuesEnumerator = estimatedValues.GetEnumerator();
+      while (targetValuesEnumerator.MoveNext() && estimatedValuesEnumerator.MoveNext()) {
+        double target = targetValuesEnumerator.Current;
+        double estimated = estimatedValuesEnumerator.Current;
+        cache[i] = estimated;
+        linearScalingCalculator.Add(estimated, target);
+        i++;
+      }
+      double alpha = linearScalingCalculator.Alpha;
+      double beta = linearScalingCalculator.Beta;
+
+      //calculate the quality by using the passed online calculator
+      targetValuesEnumerator = targetValues.GetEnumerator();
+      var scaledBoundedEstimatedValuesEnumerator = Enumerable.Range(0, i).Select(x => cache[x] * beta + alpha)
+        .LimitToRange(lowerEstimationLimit, upperEstimationLimit).GetEnumerator();
+
+      while (targetValuesEnumerator.MoveNext() & scaledBoundedEstimatedValuesEnumerator.MoveNext()) {
+        calculator.Add(targetValuesEnumerator.Current, scaledBoundedEstimatedValuesEnumerator.Current);
+      }
+    }
+  }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Grammar.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Grammar.cs	(revision 9260)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Grammar.cs	(revision 9262)
@@ -41,5 +41,5 @@
     private const string BooleanConstant = "Boolean Constant";
     private const string TradeMean = "Average Trade";
-    private const string MACDIndicator = "MACD Indicator";
+    private const string Indicators = "Indicators";
     private const string SerialTime = "Serial Operators";
       
@@ -64,7 +64,6 @@
 
         var mean = new AverageTrade();
-        var expMovAverage = new EMA();
         var macd = new MACD();
-        var RSI = new RSI();
+        var rsi = new RSI();
 
         var gt = new GreaterThan();
@@ -91,5 +90,5 @@
         var booleanConstantsSymbols = new GroupSymbol(BooleanConstant, new List<ISymbol> { boolean });
         var meanTradeSymbols = new GroupSymbol(TradeMean, new List<ISymbol> { mean});
-        var indicatorTradeSymbols = new GroupSymbol(MACDIndicator, new List<ISymbol> { macd,RSI, expMovAverage });
+        var indicatorTradeSymbols = new GroupSymbol(Indicators, new List<ISymbol> { macd,rsi});
         
         var serialTime = new GroupSymbol(SerialTime, new List<ISymbol> {max,min, lag });
@@ -110,10 +109,8 @@
         SetSubtreeCount(arithmeticSymbols, 2, 2);
         SetSubtreeCount(terminalSymbols, 0, 0);
-
         SetSubtreeCount(booleanConstantsSymbols, 0, 0);
         SetSubtreeCount(meanTradeSymbols, 1, 1);
         SetSubtreeCount(macd, 3, 3);
-        SetSubtreeCount(RSI, 1, 1);
-        SetSubtreeCount(expMovAverage, 1, 1);
+        SetSubtreeCount(rsi, 1, 1);
         SetSubtreeCount(comparisonSymbols, 2, 2);
         SetSubtreeCount(and, 2, 2);
@@ -124,11 +121,11 @@
 
       #region allowed child symbols configuration
-        //AddAllowedChildSymbol(StartSymbol, booleanOperationSymbols);
-        //AddAllowedChildSymbol(StartSymbol, comparisonSymbols);
-        AddAllowedChildSymbol(StartSymbol, expMovAverage);
+        AddAllowedChildSymbol(StartSymbol, booleanOperationSymbols);
+        AddAllowedChildSymbol(StartSymbol, comparisonSymbols);
 
         AddAllowedChildSymbol(booleanOperationSymbols, comparisonSymbols);
         AddAllowedChildSymbol(booleanOperationSymbols, booleanConstantsSymbols);
-        //AddAllowedChildSymbol(booleanOperationSymbols, indicatorTradeSymbols);
+        AddAllowedChildSymbol(booleanOperationSymbols, indicatorTradeSymbols);
+        AddAllowedChildSymbol(booleanOperationSymbols, booleanOperationSymbols);
 
         AddAllowedChildSymbol(comparisonSymbols, meanTradeSymbols);
@@ -142,8 +139,7 @@
         AddAllowedChildSymbol(arithmeticSymbols, serialTime);
 
+        AddAllowedChildSymbol(indicatorTradeSymbols, constantint);
         AddAllowedChildSymbol(serialTime, constantint);
-
-        AddAllowedChildSymbol(meanTradeSymbols, constantint);
-        AddAllowedChildSymbol(indicatorTradeSymbols, constantint);
+        AddAllowedChildSymbol(meanTradeSymbols, constantint);   
       #endregion
     }
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/HeuristicLab.Problems.TradeRules-1.0.csproj
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/HeuristicLab.Problems.TradeRules-1.0.csproj	(revision 9260)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/HeuristicLab.Problems.TradeRules-1.0.csproj	(revision 9262)
@@ -96,23 +96,36 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AverageTrade.cs" />
-    <Compile Include="BoolConstant.cs" />
-    <Compile Include="BoolConstantTreeNode.cs" />
-    <Compile Include="ConstantInt.cs" />
-    <Compile Include="ConstantIntTreeNode.cs" />
-    <Compile Include="EMA.cs" />
-    <Compile Include="EvaluatorTradeRules.cs" />
+    <Compile Include="Symbols\AverageTrade.cs" />
+    <Compile Include="Symbols\BoolConstant.cs" />
+    <Compile Include="Symbols\BoolConstantTreeNode.cs" />
+    <Compile Include="Symbols\ConstantInt.cs" />
+    <Compile Include="Symbols\ConstantIntTreeNode.cs" />
+    <Compile Include="Evaluator\EvaluatorTradeRules.cs" />
     <Compile Include="Grammar.cs" />
     <Compile Include="Interpreter.cs" />
-    <Compile Include="Lag.cs" />
-    <Compile Include="MACD.cs" />
-    <Compile Include="Max.cs" />
-    <Compile Include="Min.cs" />
+    <Compile Include="Symbols\ITradeRulesExpresionTree.cs" />
+    <Compile Include="ITradeRulesModel.cs" />
+    <Compile Include="Solution\ITradeRulesSolution.cs" />
+    <Compile Include="Solution\ITradingRulesSolution.cs" />
+    <Compile Include="Symbols\Lag.cs" />
+    <Compile Include="Symbols\MACD.cs" />
+    <Compile Include="Symbols\MACDTreeNode.cs" />
+    <Compile Include="Symbols\Max.cs" />
+    <Compile Include="Symbols\Min.cs" />
+    <Compile Include="Evaluator\OnlineTradeRulesCalculator.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\HeuristicLab.Problems.TradeRules-1.0.cs" />
-    <Compile Include="RSI.cs" />
-    <Compile Include="TradeAnalysisProblem.cs" />
-    <Compile Include="TradeRulesAbstractProblem.cs" />
-    <Compile Include="TradeRulesProblem.cs" />
+    <Compile Include="Symbols\RSI.cs" />
+    <Compile Include="Evaluator\TradeRulesAnalysisEvaluator.cs" />
+    <Compile Include="Evaluator\TradeRulesAnalysisSingleObjectiveEvaluator.cs" />
+    <Compile Include="Evaluator\TradeRulesSingleObjectiveEvaluator.cs" />
+    <Compile Include="Problem\TradeAnalysisProblem.cs" />
+    <Compile Include="Problem\TradeRulesAbstractProblem.cs" />
+    <Compile Include="Problem\TradeRulesProblem.cs" />
+    <Compile Include="TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer.cs" />
+    <Compile Include="TradeRulesSingleObjectiveValidationBestSolutionAnalyzer.cs" />
+    <Compile Include="Solution\TradeRulesSolution.cs" />
+    <Compile Include="Solution\TradeRulesSolutionBase.cs" />
+    <Compile Include="Solution\TradingRulesSolution.cs" />
   </ItemGroup>
   <ItemGroup>
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/ITradeRulesModel.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/ITradeRulesModel.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/ITradeRulesModel.cs	(revision 9262)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    public interface ITradeRulesModel : IDataAnalysisModel {
+    IEnumerable<double> GetEstimatedValues(Dataset dataset, IEnumerable<int> rows);
+    ITradeRulesSolution CreateRegressionSolution(IRegressionProblemData problemData);
+  }
+}
